Overview | Package | Class | Tree | Deprecated | Index | Help
| For the latest news and information visit The GNU Crypto project
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## gnu.crypto.sig.dss
Class DSSKeyPairRawCodec

    java.lang.Object
      |
      +--gnu.crypto.sig.dss.DSSKeyPairRawCodec

All Implemented Interfaces:
  IKeyPairCodec

public class DSSKeyPairRawCodec
extends java.lang.Object
implements IKeyPairCodec

An object that implements the `IKeyPairCodec` operations for the Raw format to use with DSS keypairs.

Version:
  $Revision: 1.2 $

Fields inherited from interface gnu.crypto.sig.IKeyPairCodec
`RAW_FORMAT`

Constructor Summary
`DSSKeyPairRawCodec()`

Method Summary
`java.security.PrivateKey` | `decodePrivateKey(byte[] k)` Decodes an instance of an external private key into its native Java representation.
`java.security.PublicKey` | `decodePublicKey(byte[] k)` Decodes an instance of an external public key into its native Java representation.
`byte[]` | `encodePrivateKey(java.security.PrivateKey key)` Returns the encoded form of the designated DSS (Digital Signature Standard) private key according to the Raw format supported by this library.
`byte[]` | `encodePublicKey(java.security.PublicKey key)` Returns the encoded form of the designated DSS (Digital Signature Standard) public key according to the Raw format supported by this library.
`int` | `getFormatID()` Returns the unique identifier (within this library) of the format used to externalise public and private keys.

Methods inherited from class java.lang.Object
`, clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### DSSKeyPairRawCodec

    public DSSKeyPairRawCodec()

Method Detail

### getFormatID

    public int getFormatID()

  Description copied from interface: `IKeyPairCodec`
  Returns the unique identifier (within this library) of the format used to externalise public and private keys.

  Specified by:
    `getFormatID` in interface `IKeyPairCodec`
  Following copied from interface: `gnu.crypto.sig.IKeyPairCodec`
  Returns:
    the identifier of the format, the object supports.

### encodePublicKey

    public byte[] encodePublicKey(java.security.PublicKey key)

  Returns the encoded form of the designated DSS (Digital Signature Standard) public key according to the Raw format supported by this library.

  The Raw format for a DSA public key, in this implementation, is a byte sequence consisting of the following:

  1. 4-byte magic consisting of the constant: 0x474E5541,
  3. 1-byte version consisting of the constant: 0x01,
  4. 4-byte count of following bytes representing the DSA parameter `p` in internet order,
  5. n-bytes representation of a `BigInteger` obtained by invoking the `toByteArray()` method on the DSA parameter `p`,
  6. 4-byte count of following bytes representing the DSA parameter `q`,
  7. n-bytes representation of a `BigInteger` obtained by invoking the `toByteArray()` method on the DSA parameter `q`,
  8. 4-byte count of following bytes representing the DSA parameter `g`,
  9. n-bytes representation of a `BigInteger` obtained by invoking the `toByteArray()` method on the DSA parameter `g`,
  10. 4-byte count of following bytes representing the DSA parameter `y`,
  11. n-bytes representation of a `BigInteger` obtained by invoking the `toByteArray()` method on the DSA parameter `y`,
  Specified by:
    `encodePublicKey` in interface `IKeyPairCodec`
  Parameters:
    `key` - the key to encode.
  Returns:
    the Raw format encoding of the designated key.
  Throws:
    `java.lang.IllegalArgumentException` - if the designated key is not a DSS (Digital Signature Standard) one.

### decodePublicKey

    public java.security.PublicKey decodePublicKey(byte[] k)

  Description copied from interface: `IKeyPairCodec`
  Decodes an instance of an external public key into its native Java representation.

  Specified by:
    `decodePublicKey` in interface `IKeyPairCodec`
  Following copied from interface: `gnu.crypto.sig.IKeyPairCodec`
  Parameters:
    `input` - the source of the externalised key to decode.
  Returns:
    a concrete instance of a public key, reconstructed from the designated input.
  Throws:
    `java.lang.IllegalArgumentException` - if the designated input does not contain a known representation of a public key for the format supported by the concrete codec.

### encodePrivateKey

    public byte[] encodePrivateKey(java.security.PrivateKey key)

  Returns the encoded form of the designated DSS (Digital Signature Standard) private key according to the Raw format supported by this library.

  The Raw format for a DSA private key, in this implementation, is a byte sequence consisting of the following:

  1. 4-byte magic consisting of the constant: 0x474E5561,
  3. 1-byte version consisting of the constant: 0x01,
  4. 4-byte count of following bytes representing the DSA parameter `p` in internet order,
  5. n-bytes representation of a `BigInteger` obtained by invoking the `toByteArray()` method on the DSA parameter `p`,
  6. 4-byte count of following bytes representing the DSA parameter `q`,
  7. n-bytes representation of a `BigInteger` obtained by invoking the `toByteArray()` method on the DSA parameter `q`,
  8. 4-byte count of following bytes representing the DSA parameter `g`,
  9. n-bytes representation of a `BigInteger` obtained by invoking the `toByteArray()` method on the DSA parameter `g`,
  10. 4-byte count of following bytes representing the DSA parameter `x`,
  11. n-bytes representation of a `BigInteger` obtained by invoking the `toByteArray()` method on the DSA parameter `x`,
  Specified by:
    `encodePrivateKey` in interface `IKeyPairCodec`
  Parameters:
    `key` - the key to encode.
  Returns:
    the Raw format encoding of the designated key.

### decodePrivateKey

    public java.security.PrivateKey decodePrivateKey(byte[] k)

  Description copied from interface: `IKeyPairCodec`
  Decodes an instance of an external private key into its native Java representation.

  Specified by:
    `decodePrivateKey` in interface `IKeyPairCodec`
  Following copied from interface: `gnu.crypto.sig.IKeyPairCodec`
  Parameters:
    `input` - the source of the externalised key to decode.
  Returns:
    a concrete instance of a private key, reconstructed from the designated input.
  Throws:
    `java.lang.IllegalArgumentException` - if the designated input does not contain a known representation of a private key for the format supported by the concrete codec.

Overview | Package | Class | Tree | Deprecated | Index | Help
| For the latest news and information visit The GNU Crypto project
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright ©2001-2002 Free Software Foundation, Inc.. All Rights Reserved.